

var USB_VENDOR_ID  = 10943; //0x2abf;
var USB_PRODUCT_ID1 = 1280; //0x0500;
var USB_PRODUCT_ID2 = 1285; //0x0505;
var USB_PRODUCT_ID3 = 4101; //0x01005;
var USB_PRODUCT_ID4 = 5381; //0x01505;

var USB_DEVICE_INFO1 = {"vendorId": USB_VENDOR_ID, "productId": USB_PRODUCT_ID1 };
var USB_DEVICE_INFO2 = {"vendorId": USB_VENDOR_ID, "productId": USB_PRODUCT_ID2 };

var CYP_VENDOR_ID  = 1204; 	//0x04b4;
var CYP_PRODUCT_ID = 46877; //0xb71d;
var CYP_DEVICE_INFO = {"vendorId": CYP_VENDOR_ID, "productId": CYP_PRODUCT_ID };

var USB_MODE_NORMAL	= 1;
var USB_MODE_PC		= 0;
var USB_MDOE_RESET	= 3;

var KERNEL_FILE  = "kernel.sebn";
var ROOTFS_FILE  = "rootfs.sebn";
var SBOOT_FILE   = "sboot.sebn";
var CYPRESS_FILE = "cypressUSB.cyacd";

var deviceFoundCallback = null;

var USBDEV_NONE  = 0;
var USBDEV_REVO1 = 1;
var USBDEV_REVO2 = 2;
var USBDEV_CYP   = 3;

var currentOperation = 0;

const HID_REPORT_ID = 4;
const HID_CMD_GET_USB = 10;
const HID_CMD_GET_DSP = 11;
const HID_CMD_GET_BUNDLE = 12;
const HID_CMD_GET_IP = 13;


var deviceFound = {type:USBDEV_NONE, state:"Disconnected"};

function disableButton(id, state) {
 	button = document.getElementById(id);
  button.disabled = state;
}

var isHidConnected = function() {
  	return (hidConnection.connId != -1 && (hidConnection.pid == USB_PRODUCT_ID3 || 
	    hidConnection.pid == USB_PRODUCT_ID4));
};

function intToChar(lineBytes) {
  var log = '';
  
  for (var j = 0; j < lineBytes.length; ++j) {
    var ch = String.fromCharCode(lineBytes[j]);
    if (lineBytes[j] < 32 || lineBytes[j] > 126)
      ch = '.';
    log += ch;
  }
  
  return log;
}

var hidConnection = {connId:-1, vid:-1, pid:-1};

  var enumerateDevices = function() {
    chrome.hid.getDevices({}, onDevicesEnumerated);
    chrome.hid.onDeviceAdded.addListener(onDeviceAdded);
    chrome.hid.onDeviceRemoved.addListener(onDeviceRemoved);
  };

  var onDevicesEnumerated = function(devices) {
    if (chrome.runtime.lastError) {
      console.error("Unable to enumerate devices: " +
                    chrome.runtime.lastError.message);
      return;
    }

    for (var device of devices) {
      onDeviceAdded(device);
    }
  };

  var keepPolling = true;

  var pollForInput = function() {
    chrome.hid.receive(hidConnection.connId , function(reportId, data) {
      logInput(new Uint8Array(data));
      console.log('received data from reportId:' + reportId);
      if (keepPolling)
        setTimeout(pollForInput, 0);
    });
  };

  var disconnectHid = function() {
		chrome.hid.disconnect(hidConnection.connId);
    hidConnection.connId = -1;
    hidConnection.vid = -1;
    hidConnection.pid = -1;
  };

  var connectHid = function(device) {
   chrome.hid.connect(device.deviceId, function(connectInfo) {
      if (!connectInfo) {
        console.warn("Unable to connect to device.");
        deviceFound.state = 'Disconnected';
        deviceFound.type = USBDEV_NONE;
      } else {
        console.log('connected to device:' + device.deviceId + ' vid ' + device.vendorId + ' pid ' + device.productId);
        hidConnection.connId = connectInfo.connectionId;
        hidConnection.vid = device.vendorId;
        hidConnection.pid = device.productId;
        deviceFound.state = device.productId == CYP_PRODUCT_ID ? 'Bootloader' : 'Connected';
 
        switch(device.productId) {
          case CYP_PRODUCT_ID:
            deviceFound.type = USBDEV_CYP;
            break;
          case USB_PRODUCT_ID1:
            deviceFound.type = USBDEV_REVO1;
            break;
          case USB_PRODUCT_ID2:
            deviceFound.type = USBDEV_REVO2;
            break;
          default:
            deviceFound.type = device.productId;
            break;
        }
        
      }
      
      deviceFoundCallback(deviceFound);
      //pollForInput();
    });
  };

  var onDeviceAdded = function(device) {
    console.log('detected device ID: ', device.deviceId);
    if (device.productId == USB_PRODUCT_ID3 || device.productId == USB_PRODUCT_ID4)
      connectHid(device);
  };

  var onDeviceRemoved = function(deviceId) {
    hidConnection.connId = -1;
    deviceFound.state = 'Disconnected';
    deviceFound.type = USBDEV_NONE;
    deviceFoundCallback(deviceFound);
  };

var byteToHex = function(value) {
    if (value < 16)
      return '0' + value.toString(16);
    return value.toString(16);
  };

  var logInput = function(bytes) {
    var log = '';
    for (var i = 0; i < bytes.length; i += 16) {
      var sliceLength = Math.min(bytes.length - i, 16);
      var lineBytes = new Uint8Array(bytes.buffer, i, sliceLength);
      for (var j = 0; j < lineBytes.length; ++j) {
        log += byteToHex(lineBytes[j]) + ' ';
      }
      for (var j = 0; j < lineBytes.length; ++j) {
        var ch = String.fromCharCode(lineBytes[j]);
        if (lineBytes[j] < 32 || lineBytes[j] > 126)
          ch = '.';
        log += ch;
      }
      log += '\n';
    }
    log += "================================================================\n";
    console.log("data:" + log);
 
  };


//function checkDevice(andCallHere) {
var checkHidDevice = function(andCallHere) {
  deviceFoundCallback = andCallHere;
  enumerateDevices();
};

//function checkDevice_unsused(andCallHere) {
var checkDevice = function(andCallHere) {
	//console.log('Checking Device');
 	var deviceIds = hidGetDeviceId();
  var devId;

	deviceFoundCallback = andCallHere;
	chrome.usb.getDevices(USB_DEVICE_INFO1, function(devices) {
		if (devices) {
			if (devices.length > 0) {
				//console.log("Device(s) found: " + devices.length);
				// in case backwards compatibility is added later
				// you can use this.
				if (0) {
					deviceFound.type = USBDEV_REVO1;
          deviceFound.state = 'Connected';
        }
				else {
					deviceFound.type = USBDEV_NONE;
          deviceFound.state = 'Disconnected';
          CloseBulkConnection();  
				}
				andCallHere(deviceFound);
			} else {
				chrome.usb.getDevices(USB_DEVICE_INFO2, function(devices) {
					if (devices) {
						if (devices.length > 0) {
							//console.log("Device(s) found: " + devices.length);
							deviceFound.type = USBDEV_REVO2;
							deviceFound.state = 'Connected';
							andCallHere(deviceFound);
						} else {
							//console.log("Rv Device could not be found, check cy");
							chrome.usb.getDevices(CYP_DEVICE_INFO, function(devices) {
								if (devices) {
									if (devices.length > 0) {
										//console.log("Device(s) found: " + devices.length);
										//console.log("CyDevice found");
										deviceFound.type = USBDEV_CYP;
										deviceFound.state = 'Bootloader';
										andCallHere(deviceFound);
									} else {
										//console.log("Cy Device could not be found");
										deviceFound.type = USBDEV_NONE;
        	          deviceFound.state = 'Disconnected';
        	          
                    // try HID connection
                    if (currentOperation === 0)
                      checkHidDevice(andCallHere);

									  CloseBulkConnection();
										andCallHere(deviceFound);
									}
								} else {
									console.log("Permission denied.");
									deviceFound.type = USBDEV_NONE;
       	          deviceFound.state = 'Disconnected';
 
                  CloseBulkConnection();
									andCallHere(deviceFound);
								}
							});
						}
					}
				});
			}
		} else {
			console.log("Permission denied.");
			deviceFound.type = USBDEV_NONE;
      deviceFound.state = 'Disconnected';
      
      CloseBulkConnection();
      
			andCallHere(deviceFound);
		}
	});
};

